  //gcc -Wall matrices.c -lm
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <assert.h>
#include <math.h>

/*--------------- AFFICHAGE ----------*/

void affiche(double t[], int n){//affiche un tableau
  for (int i=0; i<n; i++)
    printf("%f ",t[i]);
}//affiche

void affiche_mat(int n, int m,
		 double ** mat){
  for (int i=0; i<n; i++){
    printf("|");
    for (int j=0; j<m; j++){
      printf("%5.2f",mat[i][j]);
      if (j<m-1) printf(" ");
    }//for j
    printf("|\n");
  }//for i
  printf("\n");
}
/*------- SOMME de matrices ----*/
double **add(int n, int m,double**M1,double **M2){
  double ** res = malloc(n*sizeof(double *));
  for (int i=0; i<n; i++)
    res[i] = malloc(m*sizeof(double));
  for (int i=0; i<n; i++){
    for (int j=0; j<m; j++)
      res[i][j]=M1[i][j]+M2[i][j];
  }
  return res;
}

void test_add(){
  int n = 2, m = 3;
  double ** M = malloc(n*sizeof(double *));
  for (int i=0; i<n; i++)
   M[i] = malloc(m*sizeof(double));
  for (int i=0; i<n; i++){
    for (int j=0; j<m; j++)
      M[i][j]=i*m + j;
  }
  affiche_mat(2,3,M);
  double ** R = add (n,m,M,M);
  affiche_mat(2,3,R);
  for (int i=0; i<n; i++)
    {free(M[i]);free(R[i]);}
  free(R);free(M);
}

int main(){
  test_add();
  return 0;
}
